/****************************************************************************
*
*   Copyright (c) 2008 www.societyofrobots.com
*   (please link back if you use this code!)
*
*   This program is free software; you can redistribute it and/or modify
*   it under the terms of the GNU General Public License version 2 as
*   published by the Free Software Foundation.
*
*   Alternatively, this software may be distributed under the terms of BSD
*   license.
*
****************************************************************************/

//Add your code here

#include "Utilities.h"


signed long int ir_servo=0; //angle of IR servo
unsigned int target_distance=0; //distance away of target
unsigned int distance_thresh=30; //acceptable target detection


//sense
void scan()
	{
	//swap scan directions
	
	/*psuedocode
	while object is detected
		scan left while object detected
	while object not detected
		scan right until object detected*/
	
	target_distance = analog(A3);//check sensor
	
	if (target_distance > distance_thresh)//object detected
		{
		if (ir_servo>250) //overflow protection
			ir_servo-=1;//scan left
		}
	else //object not detected
		{
		if (ir_servo<1000) //overflow protection
			ir_servo+=1; //scan right
		else //if scanned all the way, this forces it to start over
			ir_servo=250;
		}
		
	//servo scan code
	output_bit(PIN_D2, 1);//139 center
	long_delay_us(130+scan_angle);
	output_bit(PIN_D2, 0);
		
	//printf("angle: %ld distance: %u\r\n", scan_angle, target_distance);//debug code
	}
	

void main() {

ir_servo=250; //reset IR scanner to straight

//system ready indicator, and start button
while(analog(A3) < 100) {printf("%u\r\n", analog(A3));}; //hand swipe to activate robot

while(1)
	{
	delay_cycles(65500);//so it doesnt change states too fast 
	
	scan();//locate target
	
	
	//movement actions
	if (ir_servo > 750)//if target is too far on right
		{
	 	wheel_left=850;
	 	wheel_right=800;//turn towards target
		ir_servo-=1;//scanner turns left while robot turns right
		}
	else if (ir_servo < 650)//if target is too far on left
		{
		wheel_left=550;
		wheel_right=550;//turn towards target
		ir_servo+=1;//scanner turns right while robot turns left
		}
	else //centered on target
		{
		wheel_left=800;
		wheel_right=550;//drive straight
		}
	}
	
while(1);
}

//thoughts, try reducing the 5000 delay, maybe doubling negative scan_angle, and reducing turning speed
